#ifndef BILLYSHEET_CHARACTER_SHEET_HPP
#define BILLYSHEET_CHARACTER_SHEET_HPP

#include "characteristic/adresse.hpp"
#include "characteristic/endurance.hpp"
#include "characteristic/chance.hpp"
#include "characteristic/habilete.hpp"
#include <random>

namespace character {
	class CharacterSheet final {
	private:
		std::mt19937_64 engine{ std::random_device{ "rdseed" }() };

		std::string caractere{};

		characteristic::Adresse adresse;

		characteristic::Endurance endurance;

		characteristic::Chance chance;

		characteristic::Habilete habilete;

		std::uint32_t health_point{ 0 };

		std::uint32_t armor{ 0 };

		std::uint32_t damage{ 0 };

		std::uint32_t glory{ 0 };

		std::uint32_t money{ 0 };
	public:
		CharacterSheet() = default;

		~CharacterSheet() noexcept = default;

		[[nodiscard]] const std::string &get_caractere() const { return caractere; }

		[[nodiscard]] const characteristic::Adresse &get_adresse() const { return adresse; }

		[[nodiscard]] const characteristic::Endurance &get_endurance() const { return endurance; }

		[[nodiscard]] const characteristic::Chance &get_chance() const { return chance; }

		[[nodiscard]] const characteristic::Habilete &get_habilete() const { return habilete; }

		[[nodiscard]] std::uint32_t get_health_point() const { return health_point; }

		[[nodiscard]] std::uint32_t get_armor() const { return armor; }

		[[nodiscard]] std::uint32_t get_damage() const { return damage; }

		[[nodiscard]] std::uint32_t get_glory() const { return glory; }

		[[nodiscard]] std::uint32_t get_money() const { return money; }
	};
}


#endif //BILLYSHEET_CHARACTER_SHEET_HPP
