#ifndef BILLYSHEET_MENU_DATA_HPP
#define BILLYSHEET_MENU_DATA_HPP

#include <filesystem>

namespace fs = std::filesystem;

namespace gui::menu {
	class MenuData final {
	private:
		friend class Menu;

		fs::path save_path{ "./" };

		std::string filename{ "character_sheet.json" };

		bool edit_mode{ true };
	public:
		MenuData() noexcept = default;

		~MenuData() noexcept = default;

		[[nodiscard]] bool is_edit_mode() const { return edit_mode; }
	};
}


#endif //BILLYSHEET_MENU_DATA_HPP
